function res = my_ols(Y,X)  
%===========================================================
%Notes: This is code to estimate OLS. 
%Data_in: Y~(N X 1)  X~(N X K)
%Produces: structure variable res
%External calls: None
%===========================================================

if size(Y,1)~=size(X,1) ,
    error('my_ols: x and y are not equally long') ;
end ; 

res.N           = length(Y) ;
res.K           = size(X,2) ; 
res.beta_hat    = (X'*X)\(X'*Y);
res.yhat        = X*res.beta_hat ;
res.resid       = Y-res.yhat ; 

res.ess         = res.yhat'*res.yhat ;
res.tss         = Y'*Y ;
res.rss         = res.resid'*res.resid ;
res.R2uc        = res.ess/res.tss ;

res.tssc        = Y'*(eye(res.N)-ones(res.N)./res.N)*Y ;
res.R2c         = 1 - res.rss/res.tssc ; 	%centered R^2, which you find as R2 in most statistical packages

res.sig2_hat    = res.rss/(res.N-res.K) ; %corrected for K covariates
res.sig_hat     = sqrt(res.sig2_hat) ; 
res.var_beta    = (X'*X)\eye(res.K)*res.sig2_hat ;

res.se_beta		= sqrt(diag(res.var_beta)) ;
res.tstat       = res.beta_hat./res.se_beta ;

% end of function 